# File tres/Scripts/tflatfiles.cl
# April 30, 2008
# By Doug Mink

# TFLATFILES - Make files with lists of FLAT images split by aperture size, fiber(s), exposure time, and binning

procedure tflatfiles (images)

string  images="*.fits"       {prompt="Images to check"}

string	fibsize=""	{prompt="FIBSIZE value to match null=all s=1.4 m=2.3 l=3.2"}
int	binning=0	{prompt="BINNING value to match 0=all 1 2"}

bool    verbose=yes     {prompt="Print process progress (y or n)"}

begin

    string ims
    bool vb

    ims = images
    vb = verbose

# Largest fiber flat field images
    if (fibsize == "" || fibsize == "l") {
        if (binning == 1 || binning == 0) {
	    if (!access ("flatl12.list"))
		trslist (ims,fibkey="FFN",binning=1,fibsize=3.2,outlist="flatl12.list",verbose=vb)
	    if (!access ("flatl3.list"))
		trslist (ims,fibkey="NNF",binning=1,fibsize=3.2,outlist="flatl3.list",verbose=vb)
	    }
        if (binning == 2 || binning == 0) {
	    if (!access ("flatlb12.list"))
		trslist (ims,fibkey="FFN",binning=2,fibsize=3.2,outlist="flatlb12.list",verbose=vb)
	    if (!access ("flatlb3.list"))
		trslist (ims,fibkey="NNF",binning=2,fibsize=3.2,outlist="flatlb3.list",verbose=vb)
	    }
	}

# Medium fiber flat field images
    if (fibsize == "" || fibsize == "m") {
        if (binning == 1 || binning == 0) {
	    if (!access ("flatm12.list"))
		trslist (ims,fibkey="FFN",binning=1,fibsize=2.3,outlist="flatm12.list",verbose=vb)
	    if (!access ("flatm3.list"))
		trslist (ims,fibkey="NNF",binning=1,fibsize=2.3,outlist="flatm3.list",verbose=vb)
	    }
        if (binning == 2 || binning == 0) {
	    if (!access ("flatmb12.list"))
		trslist (ims,fibkey="FFN",binning=2,fibsize=2.3,outlist="flatmb12.list",verbose=vb)
	    if (!access ("flatmb3.list"))
		trslist (ims,fibkey="NNF",binning=2,fibsize=2.3,outlist="flatmb3.list",verbose=vb)
	    }
	}

# Small fiber flat field images
    if (fibsize == "" || fibsize == "s") {
        if (binning == 1 || binning == 0) {
	    if (!access ("flats12.list"))
		trslist (ims,fibkey="FFN",binning=1,fibsize=1.4,outlist="flats12.list",verbose=vb)
	    if (!access ("flats3.list"))
		trslist (ims,fibkey="NNF",binning=1,fibsize=1.4,outlist="flats3.list",verbose=vb)
	    }
        if (binning == 2 || binning == 0) {
	    if (!access ("flatsb12.list"))
		trslist (ims,fibkey="FFN",binning=2,fibsize=1.4,outlist="flatsb12.list",verbose=vb)
	    if (!access ("flatsb3.list"))
		trslist (ims,fibkey="NNF",binning=2,fibsize=1.4,outlist="flatsb3.list",verbose=vb)
	    }
	}

end

# Jan 11 2008	New task
# Apr 30 2008	Add fibsize and binning parameters to speed processing
