# File tres/Scripts/tmonth.cl
# By Doug Mink
# February 19, 2009

# TMONTH -- List dates of given month with data directories

procedure tmonth (datemon)

string	datemon="now"	{prompt="Date for images (now=today)"}

bool	verbose=no	{prompt="Print intermediate information (yes or no)"}
bool	debug=no	{prompt="Print more information for debugging (yes or no)"}

begin
    bool vb, db
    int iday, ndir, imon
    file ddir
    string dmon, dt
    string idir		# Root directory with raw data
    string qdir		# Root directory for quicklook data

    vb = verbose
    db = debug
    dmon = datemon

    fixdir (trsdate.instdir)
    idir = fixdir.newdir
    if (!access (idir)) {
	print ("TMONTH: Raw data directory ",idir, " not found")
	return
	}

    fixdir (trsdate.quickdir)
    qdir = fixdir.newdir

    if (dmon == "now") {
	gettime (0.0, timediff=99)
	ddir = substr (gettime.datadir,1,4) // "." // substr (gettime.datadir,6,7)
	}
    else {
	imon = int (dmon)
	if (imon > 10000) {
	    ddir = substr (dmon,1,4) // "." // substr (dmon,5,6)
	    }
	else if (imon < 1000) {
	    if (substr (dmon,1,1) != "0") {
		ddir = "200" // substr (dmon,1,1) // "." // substr (dmon,2,3)
		}
	    else {
		ddir = "20" // substr (dmon,1,2) // "." // substr (dmon,3,4)
		}
	    }
	else {
	    ddir = substr (dmon, 1, 4) // "." // substr (dmon, 6,7)
	    }
	}	

    if (db)
	print ("TMONTH: Looking for directories in ", ddir)

    ndir = 0
    trsdate.verbose = db
    for (iday = 1; iday < 32; iday = iday + 1) {
	if (iday < 10) {
	    dt = ddir // "0" // iday
	    }
	else {
	    dt = ddir // iday
	    }
	if (db) {
	    print ("TMONTH: Checking for data from ", dt)
	    }
	trsdate (dt)
	if (trsdate.wdir != "" && trsdate.rdir != "") {
	    print (trsdate.rdir, " -> ", trsdate.wdir)
	    ndir = ndir + 1
	    }
	else if (trsdate.rdir != "") {
	    print (trsdate.rdir, " -> none ")
	    ndir = ndir + 1
	    }
	}
    if (ndir == 0)
	print ("TMONTH: No data found for month ",ddir)

end

# Feb 19 2009	New program
