# File tres/Scripts/tpmake.cl
# By Doug Mink
# February 13, 2009

# TPMAKE -- Extract aperture spectra from a flat field or other high-flux object
#          image, divide the sky aperture by the object aperture, and make a
#          throughput correcting spectrum to be used for background subtraction.

procedure tpmake (tpfile)

file tpfile=""		{prompt="Image from which to extract two fibers"}

file	aproot="flat"	{prompt="Root filename for aperature reference spectrum"}
file	apdir="tresdata$"	{prompt="Directory for reference spectra"}
file	tproot="tp"	{prompt="Output file root"}
bool	verbose=yes	{prompt="Log progress (yes or no)"}
bool	debug=no	{prompt="Print output (yes or no)"}

begin

    bool vb, db, first, first1, first2, odd, bfit, ia
    int i, io, ncoeff, icoeff, nfib
    file idbpath, odbpath, odbpath1, odbpath2
    file ffile, outfile, outfile1, outfile2, oldfile,otpf
    string s1, s2, s3, s4, s5, s6, s7, s8, null, flat, idbfile
    string outroot, outroot1, outroot2, filepath, dataroot, apfib
    int oldap, newap

    vb = verbose
    db = debug
    null = ""
    flat = "flat"
    ia = interact

# Quit if input file is not there
    tpf = tpfile
    if (!access (tpf)) {
	print ("TPMAKE: Throughput reference image ",tpf, " does not exist")
	return
	}

# Find fiber information for this file
    textract.aproot = "flat"
    textract.apdir = "tresdata$"
    textract.recenter = yes
    textract.overwrite = yes
    textract.orders = "1-51"
    textract.readnoise = "1"
    textract.gain = "1"
    textract.npeaks = 0.2
    textract.interactive = no
    textract.review = no
    textract.deltemp = yes
    textract.spec1 = ""
    textract.spec2 = ""
    textract.spec3 = ""
    textract.verbose = vb
    textract.debug = db
    textract (tpf)

# Make throughput ratio file
    if (textract.spec1 != "" && textract.spec2 != "") {
	tfib1 (tpf)
	otpf = tproot // tfib1.apsize // tfib1.binning // ".ec.fits"

# Delete existing output standard flat field file if already exists
	if (access (otpf)) {
	    if (vb) {
		print ("TPMAKE: Deleting existing ", otpf)
		}
	    delete (otpf)
	    }
	tarith (textract.spec2, "/", textract.spec1, otpf)
	if (vb) {
	    print ("TPMAKE: Throughput file ", otpf, " made")
	    }
	}
    else if (vb) {
	print ("TPMAKE: Throughput file not made")
	}
    return

end

# Feb 13 2009	New task to make sky/object relative throughput file
