# File tres/Scripts/trspec.cl
# December 4, 2008
# By Doug Mink

# TRSPEC: List spectra for specified object and configuration

procedure trspec (object)

string	object=""	{prompt="Object for which to search"}
string	apfib=""	{prompt="TRES configuration"}
file	dbfile="tresdata$tresdb.tab"	{prompt="TRES database file"}
int	program=0	{prompt="Program number for which to search (0=all)"}
bool	deltemp=yes	{prompt="Delete temporary file (yes or no)"}
bool	verbose=no	{prompt="Summarize results (yes or no)"}

struct *filelist

begin
    file templist, dbf
    string obj, ims, imtype, ra, dec, apf, fibkey, pstr, specfile, pc
    int p1, prognum, nspec
    bool vb, dt
    string mjd, exp, comp, progname

    dt = deltemp
    vb = verbose
    dbf = osfn (dbfile)
    nspec = 0
    templist = mktemp ("tempobj") // ".list"
    exp = "0"
    comp = "0"

    if (object != "") {
	if (vb)
	    print ("TRSPEC: tail ",dbf," nlines=-2 | grep -i ",object," >",templist)
	tail (dbf, nlines=-2) | grep ("-i",object, >templist)
	if (vb) {
	    wc ("-l", templist) | scan (nspec)
	    print ("TRSPEC: ",nspec," spectra matched object name ",object)
	    }
	}
    else if (program > 0) {
	pstr = program
	if (vb)
	    print ("TRSPEC: grep -i ",pstr, " ", dbf, " >",templist)
	grep ("-i", pstr, dbf, >templist)
	if (vb) {
	    wc ("-l", templist) | scan (nspec)
	    print ("TRSPEC: ",nspec," spectra matched program ",pstr)
	    }
	}
    else if (apfib != "") {
	if (vb)
	    print ("TRSPEC: grep -i ",apfib, " ", dbf, " >",templist)
	grep ("-i", apfib, dbf, >templist)
	if (vb) {
	    wc ("-l", templist) | scan (nspec)
	    print ("TRSPEC: ",nspec," spectra matched configuration ",apfib)
	    }
	}
    else {
	print ("TRSPEC: No search limit set")
	return
	}


# Process object and sky files from lists
    nspec = 0
    if (access (templist)) {

	filelist = templist
	while (fscan(filelist,specfile,obj,imtype,ra,dec,mjd,apf,fibkey,exp,comp,pstr) != EOF){

	    if (vb) {
		print (specfile," ",obj," ",imtype," ",ra," ",dec," ",mjd," ",apf," ",fibkey," ",exp," ",comp," ",pstr)
		}

# Extract program number
	    if (substr(pstr,1,1) == "#")
		p1 = 2
	    else {
		p1 = 1
		}
	    isnum (substr(pstr,p1,p1)
	    if (isnum.fpcode == 0) {
		prognum = 0
		progname = pstr
		}
	    else {
		pc = substr(pstr,p1,p1)
		prognum = int (pc)
		p1 = p1 + 1
		pc = substr (pstr, p1, p1)
		if (pc != " " && pc != "_") {
		    prognum = (prognum * 10) + int (pc)
		    p1 = p1 + 1
		    pc = substr (pstr, p1, p1)
		    if (pc != " " && pc != "_") {
			p1 = p1 + 1
			pc = substr (pstr, p1, p1)
			if (pc != " " && pc != "_") {
			    prognum = (prognum * 10) + int (pc)
			    }
			}
		    }
		p1 = p1 + 1
		progname = substr(pstr,p1,100)
		}

# Skip this spectrum if it is not in the desired program
	    if (program > 0 && prognum != program)
		next

# Skip this spectrum if it is not the desired configuration
	    if (apfib != "" && apf != apfib)
		next

	    print (specfile," ",obj," ",ra," ",dec," ",apf," ",fibkey," ",exp," ",prognum," ",progname)

	    nspec = nspec + 1
	    }
	}
    else {
	print ("TRSPEC: No objects found matching ", object, " ", apfib, " ", program)
	return
	}
    
    if (verbose){
	print ("TRSPEC: ",nspec," spectra found matching ", object, " ", apfib, " ", program)
	}

    if (dt) {
	delete (templist)
	}

    filelist = ""
end

# Dec  3 2008	New task
# Dec  4 2008	Print RA and DEC instead of IMAGETYP and COMPTIME
